--[[
Copyright 2010, 2011 William Matthews. All rights reserved.

See LICENSE for license terms.
]]

local CB = select(2,...)
local P = CB.Private
local Hacks = P:NewModule("Hacks", "AceEvent-3.0")
local L = P.L

local function hackHookEnchantShop()
	local orig = EnchantShop.CreateReagentStorageString
	local hook = function(self,reagent)
		local id = self.db.profile.reagents[reagent].itemId
--		CB:DebugPrint({reagent=reagent,id=id})
		if not id then
			return format("no id for %s",tostring(reagent))
		end
		local owned = P:GetTotalCBItemCount(id)
		local needed = self.requiredReagents[reagent] or 0
		local cb = CB:QueryItem(id)
		return format("Owned: |cffffffff%d|r Req: |cffffffff%d|r CB: |cffffffff%s|r",owned,needed,P.moneyOrUnknown(cb))
	end
	EnchantShop.CreateReagentStorageString = hook
	P:Print("EnchantShop hooked")
end

local function hackHookAPMPricer()
	LibStub("AceAddon-3.0"):GetAddon("APM-Pricer"):RegisterVariable("costbasis",function(id)
		return CB:QueryItem(id)
	end)
	P:Print("APM-Pricer hooked")
end

local function hookTSM()
	if TSMAPI and TSMAPI.AddPriceSource then
		TSMAPI:AddPriceSource("CostBasis",L["Cost Basis"],
			function(itemLink,itemID) return CB:QueryItem(itemID) end)
		P:Print("TSM hooked")
	else
		P:Print("TSM hook failed")
	end
end

local function doHack(hack)
	local status,error=pcall(hack)
	if not status then
		P:DebugPrint(error)
	end
end

function Hacks:OnInitialize()
	doHack(hackHookEnchantShop)
	doHack(hackHookAPMPricer)
	doHack(hookTSM)
end
