--[[
Copyright 2010, 2011 William Matthews. All rights reserved.

See LICENSE for license terms.
]]

local CB = select(2,...)
local P = CB.Private
local Tools = P:NewModule("Tools", "AceEvent-3.0")

local TOOLS = {}
local DATA

function Tools:OnInitialize()
	P.G.ToolData = P.G.ToolData or {}
	DATA = P.G.ToolData
	P:RegisterSlashVerb("tool","toolname","run internal tools",function(nextArg)
		local tool=nextArg()
		if tool and TOOLS[tool] then
			TOOLS[tool](nextArg)
		else
			P:Print("Unknown tool.  See file Tools.lua.")
		end
	end)	
end

function TOOLS.enchantTable()
	local errors=0
	DATA.ENCHANT_SPELL_TO_SCROLL = DATA.ENCHANT_SPELL_TO_SCROLL or {}
	for _,scrollId in pairs(P.ENCHANTING_SCROLLS) do
		local scroll = GetItemInfo(scrollId)
		local spell = GetItemSpell(scrollId)
		if spell then
			DATA.ENCHANT_SPELL_TO_SCROLL[spell]=scroll
		else
			P:Printf("No spell for item '%s' (%d).",scroll or "Unknown",scrollId)
			errors=errors+1
		end
	end
	P:Printf("Done.  %d error(s).",errors)
end